/* Code generated by cmd/cgo; DO NOT EDIT. */

/* package command-line-arguments */


#line 1 "cgo-builtin-export-prolog"

#include <stddef.h> /* for ptrdiff_t below */

#ifndef GO_CGO_EXPORT_PROLOGUE_H
#define GO_CGO_EXPORT_PROLOGUE_H

#ifndef GO_CGO_GOSTRING_TYPEDEF
typedef struct { const char *p; ptrdiff_t n; } _GoString_;
#endif

#endif

/* Start of preamble from import "C" comments.  */


#line 3 "pbcts.go"

   #include <stdlib.h>

   struct Data {
    int size;
    void* data;
    };

   struct IntAndError {
    int error;
    int val;
    };

   struct DataAndError {
    int error;
    struct Data data;
    };

   struct Reference {
    int error;
    long reference;
    };

   struct Round1Data {
    int error;
    struct Data unicastLengths;
    struct Data unicastData;
    struct Data broadcastData;
    };

   struct Round7Data {
    int error;
    char* keyId;
    struct Data preSigIds;
    struct Data honestPlayers;
    };

   struct CombinedSig {
    int error;
    struct Data signature;
    struct Data contributors;
    };


#line 1 "cgo-generated-wrapper"


/* End of preamble from import "C" comments.  */


/* Start of boilerplate cgo prologue.  */
#line 1 "cgo-gcc-export-header-prolog"

#ifndef GO_CGO_PROLOGUE_H
#define GO_CGO_PROLOGUE_H

typedef signed char GoInt8;
typedef unsigned char GoUint8;
typedef short GoInt16;
typedef unsigned short GoUint16;
typedef int GoInt32;
typedef unsigned int GoUint32;
typedef long long GoInt64;
typedef unsigned long long GoUint64;
typedef GoInt64 GoInt;
typedef GoUint64 GoUint;
typedef __SIZE_TYPE__ GoUintptr;
typedef float GoFloat32;
typedef double GoFloat64;
typedef float _Complex GoComplex64;
typedef double _Complex GoComplex128;

/*
  static assertion to make sure the file is being used on architecture
  at least with matching size of GoInt.
*/
typedef char _check_for_64_bit_pointer_matching_GoInt[sizeof(void*)==64/8 ? 1:-1];

#ifndef GO_CGO_GOSTRING_TYPEDEF
typedef _GoString_ GoString;
#endif
typedef void *GoMap;
typedef void *GoChan;
typedef struct { void *t; void *v; } GoInterface;
typedef struct { void *data; GoInt len; GoInt cap; } GoSlice;

#endif

/* End of boilerplate cgo prologue.  */

#ifdef __cplusplus
extern "C" {
#endif


// pbctsNew takes a filename and backup filename, and a database encryption key
// and returns a new player reference that can be tracked
// externally. databaseFilename cannot point to an existing file. If
// databaseFilename already exists, there's a chance PbctsLoad should be used
// instead.
extern struct Reference pbctsNew(GoString databaseFilename, GoString databaseBackupFilename, GoSlice databaseKey);

// pbctsLoad loads an existing player from a database and returns an externally
// trackable reference to it. databaseFilename should point to the database
// where the player object is stored.
extern struct Reference pbctsLoad(GoString databaseFilename, GoString databaseBackupFilename, GoSlice databaseKey);

// pbctsNewKeyGenSession takes an player reference, player identifier ID, player
// count N, pre-signature count M, and session ID, and creates a new externally
// trackable reference for a key generation protocol for N players that will
// generate M pre-signatures, and where this player has the id ID.
extern struct Reference pbctsNewKeyGenSession(GoInt64 playerReference, GoInt playerIndex, GoInt playerCount, GoInt preSignatureCount, GoString sessionId);

// pbctsResumeKeyGenSession attempts to resume a key-gen session from a provided
// session ID.
extern struct Reference pbctsResumeKeyGenSession(GoInt64 playerReference, GoString sessionId);

// pbctsFlushKeyGenSessionCache flushes all sessions that are held in memory. Existing sessions are
// invalidated after calling this function.
extern GoUint8 pbctsFlushKeyGenSessionCache(GoInt64 playerReference);

// pbctsPublicKey takes a player reference, key ID and returns the public key
// associated with the key ID.
extern struct DataAndError pbctsPublicKey(GoInt64 playerReference, GoString keyId);

// pbctsSign takes a player reference, public key ID, pre-signature ID, message
// hash and pre-signature randomizer, and partially signs the provided
// message. The pre-signature ID specifies which pre-signature to use and the
// pre-signature randomizer is used to re-randomize the pre-signature before
// usage.
extern struct DataAndError pbctsSign(GoInt64 playerReference, GoString keyId, GoString preSignatureId, GoSlice message, GoSlice preSignatureRandomizer);

// pbctsCombine takes a list of partial signatures and returns a full ECDSA
// signature (r, s) where each of r and s are 32 byte big-endian values.
extern struct CombinedSig pbctsCombine(GoSlice partialSignatures);

// pbctsDeleteKeyShare deletes an existing key share from the database.
extern GoUint8 pbctsDeleteKeyShare(GoInt64 playerReference, GoString keyId);

// pbctsDeletePreSignature deletes the data associated with a particular
// pre-signature ID.
extern GoUint8 pbctsDeletePreSignature(GoInt64 playerReference, GoString keyId, GoString preSignatureId);

// pbctsDeleteAllPreSignatures delete all pre-signature data associated with a
// particular key ID.
extern GoUint8 pbctsDeleteAllPreSignatures(GoInt64 playerReference, GoString keyId);

// pbctsPreSignatureCount count the number of available pre-signatures for a
// given key ID.
extern struct IntAndError pbctsPreSignatureCount(GoInt64 playerReference, GoString keyId);

// pbctsListPreSignatureIds lists all the pre-signature IDs associated with a
// key ID. This function allocates memory that must be freed by the caller.
extern struct DataAndError pbctsListPreSignatureIds(GoInt64 playerReference, GoString keyId);

// pbctsRound1 runs round 1 of the key generation protocol.
extern struct Round1Data pbctsRound1(GoInt64 sessionReference);

// pbctsRound2 runs round 2 of the key generation protocol.
extern struct DataAndError pbctsRound2(GoInt64 sessionReference, GoSlice round1UnicastMessages, GoSlice round1BroadcastMessages);

// pbctsRound3 runs round 3 of the key generation protocol.
extern struct DataAndError pbctsRound3(GoInt64 sessionReference, GoSlice round2BroadcastMessages);

// pbctsRound4 runs round 4 of the key generation protocol.
extern struct DataAndError pbctsRound4(GoInt64 sessionReference, GoSlice round3BroadcastMessages);

// pbctsRound5 runs round 5 of the key generation protocol.
extern struct DataAndError pbctsRound5(GoInt64 sessionReference, GoSlice round4BroadcastMessages);

// pbctsRound6 runs round 6 of the key generation protocol.
extern struct DataAndError pbctsRound6(GoInt64 sessionReference, GoSlice round5BroadcastMessages);

// pbctsRound7 runs the 7'th and final round of the key generation protocol.
extern struct Round7Data pbctsRound7(GoInt64 sessionReference, GoSlice round6BroadcastMessages);

// pbctsClose closes the database object held by a player.
extern GoUint8 pbctsClose(GoInt64 playerReference);

// pbctsDeleteSession deletes a session given its associated reference
extern GoUint8 pbctsDeleteSession(GoInt64 sessionReference);

#ifdef __cplusplus
}
#endif
